import monitor.*;

//**********************************************************************/ 
// definizione di una classe che vuole rappresentare un tipo MONITOR:   /
//**********************************************************************/ 

public class CampoGolf extends Monitor {

//**********************************************************************/ 
// dichiarazione delle variabili di stato del MONITOR					/
//**********************************************************************/ 

	int P; 			// numero massimo delle palline
	int palledisp; 	// numero delle palline disponibili
	int gioccoda[]; // numero dei giocaori in coda (abbiamo 2 tipi di giocatori)

//**********************************************************************/ 
// dichiarazione di variabili condition del MONITOR						/
//**********************************************************************/ 
	
	Cond coda[]; 	// code su cui sospendere i processi

//**********************************************************************/ 
// costruttore della classe MONITOR										/
//**********************************************************************/ 

    public CampoGolf (int P) {    
	    // inizializzazione delle variabili di stato
	    // e creazione delle variabili condizione
		this.P = P;
		palledisp = P;
		gioccoda =  new int[2]; 
		
		coda = new Cond[2];
		for (int i = 0; i < 2; i++)
		{
			gioccoda[i] = 0;
			coda[i] = new Cond(this);
		}
    }

//**********************************************************************/ 
// definizione delle procedure e funzioni Entry del MONITOR				/
//**********************************************************************/ 

    //Utilizzato dal gioctore
   public void  richiedi(int t, int p,  String nome) {
        // t: tipo (0=esperto, 1=principiante)
        // p: n. delle palline richieste

        // come prima istruzione bisogna invocare entraMonitor
        entraMonitor();

        while ((palledisp < p) || // se le palline disponibili sono meno di p 
        		((t==1) && (coda[0].queue())) // priorita' nell'acquisizione
        		) 
        {
			// sospensione
			gioccoda[t] ++;
		    System.out.println(nome+" mi sospendo (chiedo "+p+" palline ma ce ne sono solo "+palledisp+")");
			coda[t].Wait();
			gioccoda[t] --;
        }
        
        System.out.println(nome+" prendo "+p+" palline su "+palledisp);
        // acquisizione delle risorse 
        palledisp = palledisp - p;
        
       // come ultima istruzione bisogna invocare esciMonitor
       esciMonitor();

    }

   // Utilizzata dal giocatore
   public void rilascia(int t, int p, String nome) {
	   	// t: tipo (0=esperto, 1=principiante)
       	// p: n. delle palline

        // come prima istruzione bisogna invocare entraMonitor
        entraMonitor();

        System.out.println(nome+" rilascio le risorse");
        // rilascio delle risorse 
        palledisp = palledisp + p;

        // risveglio prima gli esperti

        int sospesi = gioccoda[0]; //uso questa variabile per risvegliare TUTTI i processi
        						  // infatti giocoda[0] viene decrementato ogni volta che faccio la Signal
        for (int i = 0; i<sospesi; i++)
        	coda[0].Signal();

        // risveglio dei principianti se non ci sono esperti in coda

       if (!coda[0].queue()) // si potrebbe anche evitare

        {

    	   sospesi = gioccoda[1]; // vedi nota sopra
          for (int i = 0; i<sospesi; i++)
        	  coda[1].Signal();

        }

       // come ultima istruzione bisogna invocare esciMonitor
       esciMonitor();

    }

}  

